package com.example.ttdvaadin.service;

import java.util.ArrayList;
import java.util.List;

import com.example.ttdvaadin.domain.Task;

public class StorageService {

	private List<Task> tasks = new ArrayList<Task>();

	public void addTask(Task task) {

		Task t = new Task();

		if (!tasks.isEmpty()) {
			t.setId((tasks.get(tasks.size()-1).getId())+1L);
		} else {
			t.setId(1L);
		}

		t.setTitle(task.getTitle());
		t.setTaskBody(task.getTaskBody());
		t.setImportance(task.getImportance());
		t.setDeadline(task.getDeadline());

		tasks.add(t);
	}
	
	public void editTask(Task task){
		
		for(Task t : tasks){
			if(t.getId().equals(task.getId())){
				t.setTitle(task.getTitle());
				t.setTaskBody(task.getTaskBody());
				t.setDeadline(task.getDeadline());
				t.setImportance(task.getImportance());
			}
		}
		
	}

	public List<Task> getAllTasks() {
		return tasks;
	}

	public void deleteTask(Task task) {
		Task toRemove = null;
		for (Task t : tasks) {
			if (t.getId() == task.getId()) {
				toRemove = t;
				break;
			}
		}
		tasks.remove(toRemove);
	}

}
