package com.example.ttdvaadin.util;
import java.util.Calendar;
import java.util.Date;

import com.vaadin.data.Validator;

public class DateBeforeValidator implements Validator {

	private static final long serialVersionUID = 1L;
	private String errorMessage = "Typed date can't be earlier than todays date.";
	private Date check;
	private Date comparisionDate;
	
	public static Date getZeroTimeDate(Date fecha) {
	    Date res = fecha;
	    Calendar calendar = Calendar.getInstance();

	    calendar.setTime( fecha );
	    calendar.set(Calendar.HOUR_OF_DAY, 0);
	    calendar.set(Calendar.MINUTE, 0);
	    calendar.set(Calendar.SECOND, 0);
	    calendar.set(Calendar.MILLISECOND, 0);

	    res = calendar.getTime();

	    return res;
	}
	
	@Override
	public void validate(Object value) throws InvalidValueException {
		
		if (isValid(value) == false){
			throw new InvalidValueException(errorMessage);
		}
		
	}

	@Override
	public boolean isValid(Object value) {
		comparisionDate = getZeroTimeDate(new Date());
		check = getZeroTimeDate((Date) value);

		if (comparisionDate.compareTo(check) > 0 ){
			return false;
		}
		return true;
	}

}
